unit KLists;
{****************************************************************}
{* ƂTListB                                    *}
{* TListāAȂ̂ق肱ǂėpIȓXg    *}
{* ǁAƎgɂƂˁB                 *}
{* Ă킯ŁATListꉻĂƕ֗ɂĂNX  *}
{* Ă݂܂B                                             *}
{* ƂNXǁAƕ֗Ɏg肷B           *}
{*==============================================================*}
{* TList̐ TIntList                                       *}
{* TListāAPointerôAėpIł񂾂     *}
{* Ɛoė~ɂ́ALXg肵         *}
{* ʓ|ˁB                                                 *}
{* ƁA킯ŁATListł炩߃LXgĂ̂      *}
{* pӂ܂B                                               *}
{* Items̑IntItemsg΂B                    *}
{*==============================================================*}
{* Object^ TObjectList                                     *}
{* TListĎj󂳂鎞Ae܂ł͉󂵂ĂȂ񂾂킳*}
{* PɁA󂷎eԂɉ󂹂΂񂾂...                *}
{* ʓ|Ȃ̂ŁAɉ󂷂̂Ƃ܂B             *}
{* ǉvpeBObjectsTObjectLXĝvpeB   *}
{* ꂱTObjectŃLXgƂ܂                        *}
{*==============================================================*}
{* FreeMem^ TFreeList                                          *}
{* Object^́AIuWFNgȂ̂ŁA           *}
{* ̓^B鎞AeFreeMemB    *}
{* 鎞́AGetMemȂAllocMemȂgĂ傤           *}
{*==============================================================*}
{* Dispose^ TDisposeList                                       *}
{* FreeMem̑DisposéB                           *}
{* gNewȂĎgȂ񂾂ǁAȒPȂ̂łĂ݂܂  *}
{* FreeMem̊ĝ̎QlɂȂ΂łB                *}
{*#Topic########################################################*}
{* Copyright (C) Kok.Wish 1997-                                 *}
{* DɎgĂB̂߂̃\[XJłB         *}
{* NX̍̕׋ɂȂ邾낤Â܂܎gĂ       *}
{* ֗Ǝv܂B                                           *}
{*==============================================================*}
{* 97/06/14(y) Kok                                             *}
{*      1st.Version UP                                          *}
{****************************************************************}
interface

uses    Classes;

{****************************************************************}
{*  TIntList                                              *}
{****************************************************************}
type
TIntList=class(TList)
private
        procedure       SetIntItems(Idx,Val:Integer);
        function        GetIntItems(Idx:Integer):Integer;
public
        destructor      Destroy; override;
        function        Add(Val:Integer):Integer;
        function        First:Integer;
        function        IndexOf(Val: Integer): Integer;
        procedure       Insert(Idx,Val:Integer);
        function        Last:Integer;
        function        Remove(Val:Integer):Integer;
        procedure       SortSmallToBig;
        procedure       SortBigToSmall;
        property        IntItems[Idx:Integer]: Integer read GetIntItems write SetIntItems; default;
end;

{****************************************************************}
{* FreeMem^ TFreeList                                          *}
{****************************************************************}
type
TFreeList=class(TList)
protected
        procedure       FreeMember(Idx:Integer); virtual;
public
        destructor      Destroy; override;
        procedure       Clear;   override;   
        procedure       Delete(Idx:Integer);
        function        Remove(Val:Pointer):Integer;
end;

{****************************************************************}
{* Dispose^ TDisposeList                                       *}
{****************************************************************}
type
TDisposeList=class(TFreeList)
protected
        procedure       FreeMember(Idx:Integer); override;
end;

{****************************************************************}
{* IuWFNg TObjectList                                   *}
{****************************************************************}
type
TObjListSortCompare = function (Item1, Item2: TObject): Integer;
TObjectList=class(TFreeList)
private
        procedure       SetObjects(Idx:Integer;Val:TObject);
        function        GetObjects(Idx:Integer):TObject;
protected
        procedure       FreeMember(Idx:Integer); override;
public
        function        Add(Val:TObject):Integer;
        function        First:TObject;
        function        IndexOf(Val:TObject): Integer;
        procedure       Insert(Idx:Integer; Val:TObject);
        function        Last:TObject;
        function        Remove(Val:TObject):Integer;
        procedure       Sort(Compare: TObjListSortCompare);
        property        Objects[Idx:Integer]: TObject read GetObjects write SetObjects; default;
end;

implementation

{****************************************************************}
{* IntList̎                                                *}
{****************************************************************}

procedure TIntList.SetIntItems(Idx,Val:Integer);
begin
        Items[Idx]:=Pointer(Val);
end;

function TIntList.GetIntItems(Idx:Integer):Integer;
begin
        result:=Integer(Items[Idx]);
end;

function TIntList.Add(Val:Integer):Integer;
begin
        result:=TList(Self).Add(Pointer(Val));
end;

procedure TIntList.Insert(Idx,Val:Integer);
begin
        TList(Self).Insert(Idx,Pointer(Val));
end;

function TIntList.First:Integer;
begin
        result:=Integer(TList(Self).First);
end;

function TIntList.Last:Integer;
begin
        result:=Integer(TList(Self).Last);
end;

function TIntList.IndexOf(Val: Integer):Integer;
begin
        result:=TList(Self).IndexOf(Pointer(Val));
end;

function TIntList.Remove(Val: Integer):Integer;
begin
        result:=TList(Self).Remove(Pointer(Val));
end;

destructor TIntList.Destroy;
begin
        while not TList(Self).Count > 0 do Remove(0);
end;

function SmallToBig(Item1,Item2: Pointer): Integer;
begin
        result:=Integer(Item1) - Integer(Item2);
end;

function BigToSmall(Item1,Item2: Pointer): Integer;
begin
        result:=Integer(Item2) - Integer(Item1);
end;

procedure TIntList.SortSmallToBig;
begin
        Sort(SmallToBig);
end;

procedure TIntList.SortBigToSmall;
begin
        Sort(BigToSmall);
end;

{****************************************************************}
{* TFreeList̎                                              *}
{****************************************************************}
destructor TFreeList.Destroy;
begin
        Clear;          { êVirtualŖ̂ŎŌĂ }
        Inherited;
end;

procedure TFreeList.FreeMember(Idx:Integer);
begin
        FreeMem(Items[Idx]);
end;

procedure TFreeList.Clear;
var
        i:      Integer;
begin
        if Count>0 then
                for i:=0 to Count-1 do
                        FreeMember(i);
        TList(Self).Clear;
end;

procedure TFreeList.Delete(Idx:Integer);
begin
        FreeMember(Idx);
        TList(Self).Delete(Idx);
end;

function TFreeList.Remove(Val:Pointer):Integer;
begin
        result:=IndexOf(val);
        if result<0 then Exit;
        Delete(Result);
end;

{****************************************************************}
{* TDisposeList̎                                           *}
{****************************************************************}
procedure TDisposeList.FreeMember(Idx:Integer);
begin
        Dispose(Items[Idx]);
end;

{****************************************************************}
{* TObjectList̎                                            *}
{****************************************************************}

procedure TObjectList.FreeMember(Idx:Integer);
begin
        Objects[Idx].Free;
end;

procedure TObjectList.SetObjects(Idx:Integer; Val:TObject);
begin
        Items[Idx]:=Val;
end;

function TObjectList.GetObjects(Idx:Integer):TObject;
begin
        Result:=TObject(Items[Idx]);
end;

function TObjectList.Add(Val:TObject):Integer;
begin
        result:=TList(Self).Add(Pointer(Val));
end;

function TObjectList.First:TObject;
begin
        result:=TObject(TList(Self).First);
end;

function TObjectList.IndexOf(Val:TObject): Integer;
begin
        result:=TList(Self).IndexOf(Pointer(Val));
end;

procedure TObjectList.Insert(Idx:Integer; Val:TObject);
begin
        TList(Self).Insert(Idx,Pointer(Val));
end;

function TObjectList.Last:TObject;
begin
        result:=TObject(TList(Self).Last);
end;

function TObjectList.Remove(Val:TObject):Integer;
begin
        result:= TFreeList(Self).Remove(Pointer(Val));
end;

procedure TObjectList.Sort(Compare: TObjListSortCompare);
begin
        TList(Self).Sort(TListSortCompare(Compare));
end;

end.
