unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ComCtrls, Grids, Menus, Math, StdCtrls, ValEdit,
  ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Quit1: TMenuItem;
    About1: TMenuItem;
    ToolBar1: TToolBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    grid: TDrawGrid;
    lboxHistory: TListBox;
    procedure   gridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure   FormCreate(Sender: TObject);
    procedure   FormDestroy(Sender: TObject);
    procedure gridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lboxHistoryDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private 錾 }
    fbmp        : TBitmap;
    FGridPreProc: TWndMethod;
    fchrom      : TStrings;
    fTempchrom  : TStrings;
    procedure   mDrawChrom(aCanvas: TCanvas; Rect: TRect; chromstring: TStrings);
    procedure   GridWndProc(var Msg: TMessage);
    procedure   mDrawRow0(aCanvas: TCanvas; Rect: TRect; ACol: integer);
    procedure   mDrawRow1(aCanvas: TCanvas; Rect: TRect; ACol: integer);
    procedure   mDrawRow2(aCanvas: TCanvas; Rect: TRect; ACol: integer);

  public
    { Public 錾 }
  end;

const
    PI     = System.Pi;
    DEG0   = PI;
    DEG90  = PI / 2;
    DEG180 = 0;
    DEG270 = 3 * DEG90;

var
    Form1: TForm1;

implementation

uses
    Unit2, Types;

{$R *.dfm}

(*
    ============================================
        ʂ̎؋Ȑ
    ============================================
*)
procedure DrawTree(fCanvas: TCanvas; n: integer; length, angle: double; factor: double = 0.7; turn: double = 0.5);  overload;
var
    dx, dy: double;
    sin, cos: Extended;
begin

    SinCos(angle, sin, cos);
    dx := length * sin;
    dy := length * cos;

    fCanvas.LineTo(Round(fCanvas.PenPos.X + dx), Round(fCanvas.PenPos.Y + dy));
    if n > 0 then begin
        DrawTree(fCanvas, n - 1, length * factor, angle + turn, factor, turn);
        DrawTree(fCanvas, n - 1, length * factor, angle - turn, factor, turn);
    end;
    fCanvas.MoveTo(Round(fCanvas.PenPos.X - dx), Round(fCanvas.PenPos.Y - dy));

end;

(*
    ============================================
        oCIt̎؋Ȑ
    ============================================
*)
procedure DrawTree(fCanvas: TCanvas; x, y: double; node, ysign, direction: integer; dx, dy: array of integer; scale: double; turn: integer);    overload;
var
    ix, iy: double;
    rdx, rdy: double;
begin
    if direction <  0 then Inc(direction,  8);
    if direction >= 8 then Inc(direction, -8);

    rdx := scale * node * dx[direction];
    rdy := ysign * scale * node * dy[direction];

    if turn = 0 then begin
        ix := x + rdx;
        iy := y + rdy;
    end else begin
        ix := x + rdy;
        iy := y + rdx;
    end;
    fCanvas.MoveTo(Round(x), Round(y));
    fCanvas.LineTo(Round(ix), Round(iy));

    if node > 0 then begin
        DrawTree(fCanvas, ix, iy, node - 1, ysign, direction - 1, dx, dy, scale, turn);
        DrawTree(fCanvas, ix, iy, node - 1, ysign, direction + 1, dx, dy, scale, turn);
    end;

end;

(*
    ============================================
        wiɐl`悷
    ============================================
*)
procedure DrawBackNumber(aCanvas: TCanvas; Rect: TRect; aNum: integer; aSize: integer);
var
    i: integer;
    Num: string;
    aWidth : integer;
    aHeight: integer;

    oldColor: TColor;
    oldSize : integer;
    oldName : string;

    oldPenColor: TColor;
    oldBrsColor: TColor;

    OldBkMode: integer;
begin
    oldColor    := aCanvas.Font.Color;
    oldSize     := aCanvas.Font.Size;
    oldName     := aCanvas.Font.Name;
    oldPenColor := aCanvas.Pen.Color;
    oldBrsColor := aCanvas.Pen.Color;

    aWidth  := Rect.Right - Rect.Left;
    aHeight := Rect.Bottom - Rect.Top;

    aCanvas.Font.Color := clGray;
    aCanvas.Font.Size  := aSize;
    aCanvas.Font.Name  := 'Century';

    Num := IntToStr(aNum);
    OldBkMode := SetBkMode(aCanvas.Handle, Integer(TRANSPARENT));
    aCanvas.TextOut(
        (aWidth - aCanvas.TextWidth(Num)) div 2,
        (aHeight - aCanvas.TextHeight(Num)) div 2,
        Num
    );
    SetBkMode(aCanvas.Handle, OldBkMode);

    i := 0;
    aCanvas.Pen.Color := clGray;
    while i < aHeight do begin
        aCanvas.Rectangle(0, i, aWidth, i + 1);
        Inc(i, 5);
    end;
    i := 1;
    aCanvas.Pen.Color := clWhite;
    while i < aHeight do begin
        aCanvas.Rectangle(0, i, aWidth, i + 1);
        Inc(i, 5);
    end;

    aCanvas.Font.Color := oldColor;
    aCanvas.Font.Size  := oldSize;
    aCanvas.Font.Name  := oldName;
    aCanvas.Pen.Color  := oldPenColor;
    aCanvas.Pen.Color  := oldBrsColor;
end;

(*
    ============================================
        `qɓˑRψ
    ============================================
*)
function GetNextChrom(oldchrom: string; changeindex: integer; deltachange: integer): string;
var
    achrom: integer;
    Temp  : TStrings;
begin
    Temp  := TStringList.Create;
    //ƗpɃRs[
    Temp.CommaText := oldchrom;
    //1ӏˑRψ(Ƃ͂ĂKI)
    achrom := StrToInt(Temp[changeindex]);
    Inc(achrom, deltachange);
    if changeindex = 8 then begin
        if achrom < 0 then achrom := 0
        else
        if achrom > 9 then achrom := 9;
    end else begin
        if achrom < -9 then achrom := -9
        else
        if achrom >  9 then achrom := 9;
    end;
    Temp[changeindex] := IntToStr(achrom);
    Result := Temp.CommaText;
    Temp.Free;
end;

(*
    ============================================
        `q`悷邽߂ɉ
    ============================================
*)
function DiverceChrom(chromstring: string; var dx: array of integer; var dy: array of integer): integer;
var
    Temp  : TStrings;
begin
    Temp  := TStringList.Create;
    Temp.CommaText := chromstring;

    dx[3] :=  StrToInt(Temp[0]);
    dx[4] :=  StrToInt(Temp[1]);
    dx[5] :=  StrToInt(Temp[2]);

    dx[0] := -dx[4];
    dx[1] := -dx[3];
    dx[2] :=      0;
    dx[6] :=      0;
    dx[7] := -dx[5];

    dy[2] := -StrToInt(Temp[3]);
    dy[3] := -StrToInt(Temp[4]);
    dy[4] :=  StrToInt(Temp[5]);
    dy[5] :=  StrToInt(Temp[6]);
    dy[6] :=  StrToInt(Temp[7]);

    dy[0] :=  dy[4];
    dy[1] :=  dy[3];
    dy[7] :=  dy[5];

    Result := StrToInt(Temp[8]);

    Temp.Free;
end;

(*
    ============================================
        wi`}
    ============================================
*)
procedure TForm1.GridWndProc(var Msg: TMessage);
begin
    if (Msg.Msg = WM_ERASEBKGND) then Msg.Result := 1 else FGridPreProc(Msg);
end;

(*
    ============================================
        
    ============================================
*)
procedure TForm1.FormCreate(Sender: TObject);
begin
    FGridPreProc := grid.WindowProc;
    grid.WindowProc := GridWndProc;

    fbmp := TBitmap.Create;
    fbmp.Height  := Screen.Height;
    fbmp.Width   := Screen.Width;
    fbmp.Canvas.Font := Self.Font;

    fchrom := TStringList.Create;
    fchrom.Add('0,0,0,0,0,0,0,0,1');
    fTempchrom := TStringList.Create;
    lboxHistory.Items.Text := fchrom.Text;
end;

(*
    ============================================
        I
    ============================================
*)
procedure TForm1.FormDestroy(Sender: TObject);
begin
    fbmp.Free;
    fchrom.Free;
    fTempchrom.Free;
end;

(*
    ============================================
        `q`
    ============================================
*)
procedure TForm1.mDrawChrom(aCanvas: TCanvas; Rect: TRect; chromstring: TStrings);
var
    achrom: integer;
    i: integer;
    posx, posy: integer;
    drawtext: string;
    OldBkMode: integer;

    dx, dy: array[0..7] of integer;
    node: integer;
begin
    posx := ((Rect.Right - Rect.Left) - aCanvas.TextWidth(StringOfChar('9', chromstring.Count))) div 2;
    posy := Rect.Top;
    for i := 0 to chromstring.Count - 1 do begin
        OldBkMode := SetBkMode(aCanvas.Handle, Integer(TRANSPARENT));
        achrom := StrToInt(chromstring[i]);
        if achrom < 0 then begin
            aCanvas.Font.Style := [fsUnderline];
        end else begin
            aCanvas.Font.Style := [];
        end;
        drawtext := IntToStr(Abs(achrom));
        aCanvas.TextOut(posx, posy, drawtext);
        SetBkMode(aCanvas.Handle, OldBkMode);
        Inc(posx, aCanvas.TextWidth(drawtext));
    end;

    if False then begin
        node := DiverceChrom(chromstring.CommaText, dx, dy);
        DrawTree(fbmp.Canvas, (Rect.Right - Rect.Left) div 2, (Rect.Bottom - Rect.Top) - 10,
                 node, 1, 2, dx, dy, 1.0, 0);
    end else begin
        node := DiverceChrom(chromstring.CommaText, dx, dy);
        DrawTree(fbmp.Canvas, (Rect.Right - Rect.Left) div 2, (Rect.Bottom - Rect.Top) div 2,
                 node, 1, 2, dx, dy, 1.0, 0);
        DrawTree(fbmp.Canvas, (Rect.Right - Rect.Left) div 2, (Rect.Bottom - Rect.Top) div 2,
                 node, 1, 2, dx, dy, 1.0, 1);
        DrawTree(fbmp.Canvas, (Rect.Right - Rect.Left) div 2, (Rect.Bottom - Rect.Top) div 2,
                 node, -1, 2, dx, dy, 1.0, 0);
        DrawTree(fbmp.Canvas, (Rect.Right - Rect.Left) div 2, (Rect.Bottom - Rect.Top) div 2,
                 node, -1, 2, dx, dy, 1.0, 1);
    end;
end;

(*
    ============================================
        }CiXψٕ`
    ============================================
*)
procedure TForm1.mDrawRow0(aCanvas: TCanvas; Rect: TRect; ACol: integer);
begin
    fTempchrom.CommaText := GetNextChrom(fchrom[fchrom.count - 1], ACol, -1);
    mDrawChrom(aCanvas, Rect, fTempchrom);
end;

(*
    ============================================
        `
    ============================================
*)
procedure TForm1.mDrawRow1(aCanvas: TCanvas; Rect: TRect; ACol: integer);
begin
    case ACol of
        0:  begin
                DrawBackNumber(aCanvas, Rect, fchrom.Count, 40);
            end;
        1:  begin
            end;
        2:  begin
            end;
        4:  begin
                fTempchrom.CommaText := fchrom[fchrom.count - 1];
                mDrawChrom(aCanvas, Rect, fTempchrom);
            end;
        5:  begin
            end;
        6:  begin
            end;
        7:  begin
            end;
        8:  begin
            end;
        9:  begin
            end;
    end;
end;

(*
    ============================================
        vXψٕ`
    ============================================
*)
procedure TForm1.mDrawRow2(aCanvas: TCanvas; Rect: TRect; ACol: integer);
begin
    fTempchrom.CommaText := GetNextChrom(fchrom[fchrom.count - 1], ACol, +1);
    mDrawChrom(aCanvas, Rect, fTempchrom);
end;

(*
    ============================================
        Z`Cxg
    ============================================
*)
procedure TForm1.gridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    aRect: TRect;
begin

    aRect := Classes.Rect(0, 0, Rect.Right - Rect.Left, Rect.Bottom - Rect.Top);

    //hԂ
    with fbmp.Canvas do begin
        Brush.Color := RGB(255,255,255);
        FillRect(aRect);
    end;

    //Zɂĕ\e؂蕪
    case ARow of
        0:  begin
                fbmp.Canvas.Brush.Color := RGB(224,192,224);
                mDrawRow0(fbmp.Canvas, aRect, ACol);
            end;
        1:  begin
                fbmp.Canvas.Brush.Color := RGB(192,192,224);
                mDrawRow1(fbmp.Canvas, aRect, ACol);
            end;
        2:  begin
                fbmp.Canvas.Brush.Color := RGB(224,192,192);
                mDrawRow2(fbmp.Canvas, aRect, ACol);
            end;
    end;

    //dグ
    BitBlt(
        grid.Canvas.Handle,
        Rect.Left,
        Rect.Top,
        Rect.Right - Rect.Left,
        Rect.Bottom - Rect.Top,
        fbmp.Canvas.Handle, 0, 0, SRCCOPY
    );

end;

(*
    ============================================
        ̑I
    ============================================
*)
procedure TForm1.gridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    col, row: integer;
begin
    TDrawGrid(Sender).MouseToCell(X, Y, col, row);
    if ((row = 0) or (row = 2)) and (col <> -1) then begin
        fchrom.Add(GetNextChrom(fchrom[fchrom.count - 1], col, row - 1));
        lboxHistory.Items.Text := fchrom.Text;
        TDrawGrid(Sender).Refresh;
    end;
end;

(*
    ============================================
        ߂
    ============================================
*)
procedure TForm1.lboxHistoryDblClick(Sender: TObject);
var
    i: integer;
    index: integer;
begin
    index := TListBox(Sender).ItemIndex;
    if index = -1 then Exit;
    for i := TListBox(Sender).Items.Count - 1 downto index + 1 do begin
        TListBox(Sender).Items.Delete(i);
    end;
    fchrom.Text := TListBox(Sender).Items.Text;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    grid.DefaultRowHeight := grid.Parent.ClientWidth div grid.RowCount;
    grid.DefaultColWidth  := grid.Parent.ClientWidth div grid.ColCount;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
    grid.DefaultRowHeight := grid.Parent.ClientHeight div grid.RowCount - 5;
    grid.DefaultColWidth  := grid.Parent.ClientWidth  div grid.ColCount - 5;
end;

end.
